---
layout: home
title: Arkenv
nav_order: 1
---

<img src="{{ site.url }}{{ site.baseurl }}/arkenv_logo.png?raw=true" width="200">


Type-safe Kotlin configuration `by` delegates.

Supports the most common external configuration sources, including:
* Command line
* Environment Variables
* Properties, Yaml, and Spring-like profiles
* `.env` files

### 📦 Installation
The quick start section contains instructions for:
* [Gradle]({{site.baseurl}}/quick-start/gradle)
* [Maven]({{site.baseurl}}/quick-start/maven)

## 🔨 Usage
* [The Basics]({{site.baseurl}}guides/the-basics)
* [Command Line guide]({{site.baseurl}}guides/command-line)

## [✨ Features]({{site.baseurl}}features/features)
* [Command Line]({{site.baseurl}}features/command-line)
* [Environment Variables]({{site.baseurl}}features/environment-variables)
* [Properties]({{site.baseurl}}features/properties)
* [Profiles]({{site.baseurl}}features/profiles)
* [Yaml Support]({{site.baseurl}}features/yaml)
* [Validation]({{site.baseurl}}features/validation)
* [Manual Input]({{site.baseurl}}features/manual-input)
* [Placeholders]({{site.baseurl}}features/placeholders)
* [Docker Secrets]({{site.baseurl}}features/docker-secrets)
* [Dot Env Files]({{site.baseurl}}features/dot-env-files)


### 🤝 Contributing [![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com)

##### Slack
Find the Arkenv channel in the [official Kotlin Slack](https://kotlinlang.slack.com/messages/CGF74HD19/).

